Package org.apache.lucene.search

## Class KnnFloatVectorQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.KnnFloatVectorQuery

- Direct Known Subclasses:
    `KnnVectorQuery`

      public class KnnFloatVectorQuery
      extends Query

  Uses `KnnVectorsReader.search(String, float[], KnnCollector, Bits)` to perform nearest neighbour search.

  This query also allows for performing a kNN search subject to a filter. In this case, it first executes the filter for each leaf, then chooses a strategy dynamically:

  - If the filter cost is less than k, just execute an exact search
  - Otherwise run a kNN search subject to the filter
  - If the kNN search visits too many vectors without completing, stop and run an exact search

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected String` | `field` |
    `protected int` | `k` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `KnnFloatVectorQuery​(String field, float[] target, int k)` | Find the `k` nearest documents to the target vector according to the vectors in the given field.
    `KnnFloatVectorQuery​(String field, float[] target, int k, Query filter)` | Find the `k` nearest documents to the target vector according to the vectors in the given field.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected TopDocs` | `approximateSearch​(LeafReaderContext context, Bits acceptDocs, int visitedLimit, KnnCollectorManager knnCollectorManager)` |
    `boolean` | `equals​(Object o)` | Override and implement query instance equivalence properly in a subclass.
    `protected TopDocs` | `exactSearch​(LeafReaderContext context, DocIdSetIterator acceptIterator)` |
    `String` | `getField()` |
    `Query` | `getFilter()` |
    `int` | `getK()` |
    `protected KnnCollectorManager` | `getKnnCollectorManager​(int k, IndexSearcher searcher)` |
    `float[]` | `getTargetCopy()` |
    `int` | `hashCode()` | Override and implement query hash code properly in a subclass.
    `protected TopDocs` | `mergeLeafResults​(TopDocs[] perLeafResults)` | Merges all segment-level kNN results to get the index-level kNN results.
    `Query` | `rewrite​(IndexSearcher indexSearcher)` | Expert: called to re-write queries into primitive queries.
    `String` | `toString​(String field)` | Prints a query to a string, with `field` assumed to be the default field and omitted.
    `void` | `visit​(QueryVisitor visitor)` | Recurse through the query tree, visiting any child queries.

    - ### Methods inherited from class org.apache.lucene.search.Query

      `classHash, createWeight, rewrite, sameClassAs, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### field

          protected final String field

    - #### k

          protected final int k

  - ### Constructor Detail

    - #### KnnFloatVectorQuery

          public KnnFloatVectorQuery​(String field,
                                     float[] target,
                                     int k)

      Find the `k` nearest documents to the target vector according to the vectors in the given field. `target` vector.
      Parameters:
        `field` - a field that has been indexed as a `KnnFloatVectorField`.
        `target` - the target of the search
        `k` - the number of documents to find
      Throws:
        `IllegalArgumentException` - if `k` is less than 1

    - #### KnnFloatVectorQuery

          public KnnFloatVectorQuery​(String field,
                                     float[] target,
                                     int k,
                                     Query filter)

      Find the `k` nearest documents to the target vector according to the vectors in the given field. `target` vector.
      Parameters:
        `field` - a field that has been indexed as a `KnnFloatVectorField`.
        `target` - the target of the search
        `k` - the number of documents to find
        `filter` - a filter applied before the vector search
      Throws:
        `IllegalArgumentException` - if `k` is less than 1

  - ### Method Detail

    - #### approximateSearch

          protected TopDocs approximateSearch​(LeafReaderContext context,
                                              Bits acceptDocs,
                                              int visitedLimit,
                                              KnnCollectorManager knnCollectorManager)
                                       throws IOException

      Throws:
        `IOException`

    - #### toString

          public String toString​(String field)

      Description copied from class: `Query`
      Prints a query to a string, with `field` assumed to be the default field and omitted.
      Specified by:
        `toString` in class `Query`

    - #### equals

          public boolean equals​(Object o)

      Description copied from class: `Query`
      Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly.

      Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical to those of the other instance. Utility methods are provided for certain repetitive code.

      See Also:
        `Query.sameClassAs(Object)`, `Query.classHash()`

    - #### hashCode

          public int hashCode()

      Description copied from class: `Query`
      Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.
      See Also:
        `Query.equals(Object)`

    - #### getTargetCopy

          public float[] getTargetCopy()

      Returns:
        the target query vector of the search. Each vector element is a float.

    - #### rewrite

          public Query rewrite​(IndexSearcher indexSearcher)
                        throws IOException

      Description copied from class: `Query`
      Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

      Callers are expected to call `rewrite` multiple times if necessary, until the rewritten query is the same as the original query.

      The rewrite process may be able to make use of IndexSearcher's executor and be executed in parallel if the executor is provided.

      However, if any of the intermediary queries do not satisfy the new API, parallel rewrite is not possible for any subsequent sub-queries. To take advantage of this API, the entire query tree must override this method.

      Overrides:
        `rewrite` in class `Query`
      Throws:
        `IOException`
      See Also:
        `IndexSearcher.rewrite(Query)`

    - #### getKnnCollectorManager

          protected KnnCollectorManager getKnnCollectorManager​(int k,
                                                               IndexSearcher searcher)

    - #### exactSearch

          protected TopDocs exactSearch​(LeafReaderContext context,
                                        DocIdSetIterator acceptIterator)
                                 throws IOException

      Throws:
        `IOException`

    - #### mergeLeafResults

          protected TopDocs mergeLeafResults​(TopDocs[] perLeafResults)

      Merges all segment-level kNN results to get the index-level kNN results.

      The default implementation delegates to `TopDocs.merge(int, TopDocs[])` to find the overall top `k`, which requires input results to be sorted.

      This method is useful for reading and / or modifying the final results as needed.

      Parameters:
        `perLeafResults` - array of segment-level kNN results.
      Returns:
        index-level kNN results (no constraint on their ordering).
      WARNING: This API is experimental and might change in incompatible ways in the next release.

    - #### visit

          public void visit​(QueryVisitor visitor)

      Description copied from class: `Query`
      Recurse through the query tree, visiting any child queries.
      Specified by:
        `visit` in class `Query`
      Parameters:
        `visitor` - a QueryVisitor to be called by each query in the tree

    - #### getField

          public String getField()

      Returns:
        the knn vector field where the knn vector search happens.

    - #### getK

          public int getK()

      Returns:
        the max number of results the KnnVector search returns.

    - #### getFilter

          public Query getFilter()

      Returns:
        the filter that is executed before the KnnVector search happens. Only the results accepted by this filter are returned by the KnnVector search.